/* bfd back-end for dlx support
   Copyright (C) 1990, 91-97, 1998 Free Software Foundation, Inc.
   Written by Steve Chamberlain of Cygnus Support.

This file is part of BFD, the Binary File Descriptor library.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include "bfd.h"
#include "sysdep.h"
#include "libbfd.h"

#define N(BITS_WORD, BITS_ADDR, NUMBER, PRINT, DEFAULT, NEXT)		\
  {							\
    BITS_WORD, /*  bits in a word */			\
    BITS_ADDR, /* bits in an address */			\
    8,	/* 8 bits in a byte */				\
    bfd_arch_dlx,					\
    NUMBER,						\
    "dlx",						\
    PRINT,						\
    3,							\
    DEFAULT,						\
    bfd_default_compatible, 				\
    bfd_default_scan,					\
    NEXT,						\
  }

enum {
I_dlx3000, 
I_dlx3900, 
I_dlx4000, 
I_dlx4010, 
I_dlx4100, 
I_dlx4300, 
I_dlx4400, 
I_dlx4600, 
I_dlx4650, 
I_dlx5000, 
I_dlx6000, 
I_dlx8000, 
I_dlx10000,
I_dlx16
};


#define NN(index) (&arch_info_struct[(index)+1])

static const bfd_arch_info_type arch_info_struct[] = 
{
  N (32, 32, bfd_mach_dlx3000, "dlx:3000", false, NN(I_dlx3000)),
  N (32, 32, bfd_mach_dlx3900, "dlx:3900", false, NN(I_dlx3900)),
  N (64, 64, bfd_mach_dlx4000, "dlx:4000", false, NN(I_dlx4000)),
  N (64, 64, bfd_mach_dlx4010, "dlx:4010", false, NN(I_dlx4010)),
  N (64, 64, bfd_mach_dlx4100, "dlx:4100", false, NN(I_dlx4100)),
  N (64, 64, bfd_mach_dlx4300, "dlx:4300", false, NN(I_dlx4300)),
  N (64, 64, bfd_mach_dlx4400, "dlx:4400", false, NN(I_dlx4400)),
  N (64, 64, bfd_mach_dlx4600, "dlx:4600", false, NN(I_dlx4600)),
  N (64, 64, bfd_mach_dlx4650, "dlx:4650", false, NN(I_dlx4650)),
  N (64, 64, bfd_mach_dlx5000, "dlx:5000", false, NN(I_dlx5000)),
  N (32, 32, bfd_mach_dlx6000, "dlx:6000", false, NN(I_dlx6000)),
  N (64, 64, bfd_mach_dlx8000, "dlx:8000", false, NN(I_dlx8000)),
  N (64, 64, bfd_mach_dlx10000, "dlx:10000", false, NN(I_dlx10000)),


  N (64, 64, bfd_mach_dlx16,   "dlx:16",   false, 0),
};

/* The default architecture is dlx:3000, but with a machine number of
   zero.  This lets the linker distinguish between a default setting
   of dlx, and an explicit setting of dlx:3000.  */

const bfd_arch_info_type bfd_dlx_arch =
N (32, 32, 0, "dlx", true, &arch_info_struct[0]);
